// **********************************************************************
// AVIClass.h
//     classe para carga de vdeos no formato AVI de imagens       
//               
// **********************************************************************

// include files for OpenGL

#include <windows.h>

#include <math.h>
#include <GL\gl.h>

// Include files for IM library
// http://www.tecgraf.puc-rio.br/im/


#include "IM/include/im.h"
#include "IM/include/im_util.h"
#include "IM/include/im_format_avi.h"
#include "IM/include/im_format_wmv.h"
#include "IM/include/im_convert.h"

#include "ImageClassNew2.h"

class AVIClass: public ImageClass
{
    imFile* ifile;
    char format[10], compression[10];
    int error, image_count;
    int width, height, color_mode, data_type;
    
    public:
    AVIClass();
    int openVideoFile(char *name);
    int loadImageFrame(int nFrame);
    void printError(int error);
    void printImageInfo(int color_mode);
    int getTotalFrames();
    void closeVideoFile();
};
