// **********************************************************************
// PUCRS/FACIN
// COMPUTAO GRFICA
//
// Arquivo: AVITest-THREE.cpp
//
// Programa de testes para carga de Imagens e vdeos AVI
//
//  Este programa deve ser compilador junto com a classe "ImageClass",
//  que est implementada no arquivo "ImageClass.cpp"
//
//  Para a carga das imagens este programa utiliza a biblioteca
//  IM http://www.tecgraf.puc-rio.br/im de autoria de Antonio Scuri
//
// Marcio Serolli Pinho
//  pinho@pucrs.br
// **********************************************************************

#include <iostream>
using namespace std;

#include "AVIClass.h"
#include <glut.h>
int cinza = false;

AVIClass Video;

// **********************************************************************
//  void init(void)
//  Inicializa os parmetros globais de OpenGL
//
// **********************************************************************
void init(void)
{
cout << "Init..." ;
    glClearColor(0.0f, 0.0f, 1.0f, 1.0f); // Fundo de tela preto
	
	// define quais os formatos de vdeo devero ser usados pelo programa 
    imFormatRegisterAVI();
	imFormatRegisterWMV();
    //if(Video.openVideoFile("3KM.avi") == 0)
    if(Video.openVideoFile("video31.wmv") == 0)
    {
        cout << "Video nao existe. Pressione ENTER para encerrar." << endl;
		getchar();
		exit (0);
    }
    cout << "Nro de Frames:" << Video.getTotalFrames() << endl;
	cout << "Fim." << endl;
}

// **********************************************************************
//  void reshape( int w, int h )
//  trata o redimensionamento da janela OpenGL
//
// **********************************************************************
void reshape( int w, int h )
{
    // Reset the coordinate system before modifying
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    // Set the viewport to be the entire window
    glViewport(0, 0, w, h);
    glOrtho(0,w,0,h,-1,1);

    // Set the clipping volume
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

}

// **********************************************************************
//  void ConverteCinza(ImageClass *Img)
// **********************************************************************
void ConverteCinza(AVIClass *V)
{
    int x,y;
    int i;
    for(y=0;y<V->SizeY();y++)
    {
        for(x=0;x<V->SizeX();x++)
        {
            i = V->GetPointIntensity(x,y);
            V->DrawPixel(x, y,i,i,i);
        }
    }
}



// **********************************************************************
//  void CalculaNivelDeZoom(float &ZoomH, float &ZoomV)
// **********************************************************************
void CalculaNivelDeZoom(float &ZoomH, float &ZoomV)
{
     ZoomH = (float)glutGet(GLUT_WINDOW_WIDTH)/Video.SizeX();
     ZoomV = (float)glutGet(GLUT_WINDOW_HEIGHT)/Video.SizeY();
}
// **********************************************************************
//  void display( void )
// **********************************************************************
int frame = 0;
void display( void )
{
	
	int loadFrameOK;
	float ZoomH, ZoomV;

	glClear(GL_COLOR_BUFFER_BIT);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-10,10,-10,10,-1,1);

	glMatrixMode (GL_MODELVIEW);
	glLoadIdentity();

	loadFrameOK = Video.loadImageFrame(frame);
	// avana o nro do frame
	frame ++;
	cout << "Frame: " << frame << endl;
	// se atingiu o final do vdeo, ento recomea
	if (frame == Video.getTotalFrames())
	{
		 frame = 0;
		// getchar();
		 return;
	}

	if (loadFrameOK) // se o frame foi corretamente carregado 
	{
	  
	  // cout << "Imagem Exibida !!" << endl;
	   Video.SetPos(-10,-10);
	   // acerta o zoom da imagem para que ocupe toda a janela
	   CalculaNivelDeZoom(ZoomH, ZoomV);
	   Video.SetZoomH(ZoomH);
	   Video.SetZoomV(ZoomV);
	   if (cinza) // se o usurio solicitou a exeibio em tons de cinza
		  ConverteCinza(&Video);

	   Video.Display();
	}
	else cout << "Erro..." << endl;

	glutSwapBuffers();
}


// **********************************************************************
//  void keyboard ( unsigned char key, int x, int y )
//
//
// **********************************************************************
void keyboard ( unsigned char key, int x, int y )
{
    switch ( key )
    {
        case 'c': cinza = !cinza;
                  glutPostRedisplay(); 
                  break;                 
        case ' ': 
                   glutPostRedisplay(); 
                   break;         
        case 27: // Termina o programa qdo
             Video.closeVideoFile();
        exit ( 0 );   // a tecla ESC for pressionada
        break;
        default:
        break;
    }
}

// **********************************************************************
//  void arrow_keys ( int a_keys, int x, int y )
//
//
// **********************************************************************
void arrow_keys ( int a_keys, int x, int y )
{
    switch ( a_keys )
    {
        case GLUT_KEY_UP:       // When Up Arrow Is Pressed...
        break;
        case GLUT_KEY_DOWN:     // When Down Arrow Is Pressed...

        break;
        default:
        break;
    }
}

// **********************************************************************
//  void main ( int argc, char** argv )
//
//
// **********************************************************************
int main ( int argc, char** argv )
{
    init ();

    glutInit            ( &argc, argv );
    glutInitDisplayMode (GLUT_DOUBLE | GLUT_DEPTH | GLUT_RGB );
    glutInitWindowPosition (10,10);

    // Define o tamanho da janela grfica do programa
    glutInitWindowSize  ( 650, 500);
    glutCreateWindow    ( "AVI Loader - v2.0" );

    glutDisplayFunc ( display );
    glutReshapeFunc ( reshape );
    glutKeyboardFunc ( keyboard );
    glutSpecialFunc ( arrow_keys );
    glutIdleFunc ( display );

//    cout << "Para ver os frames do video pressione a barra de espao" << endl;


    glutMainLoop ( );
    cout <<"FIM\n";

    return 0;
}


